codeforces 711D D. Directed Roads(dfs)

题目链接:

D. Directed Roads

time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

ZS the Coder and Chris the Baboon has explored Udayland for quite some time. They realize that it consists of n towns numbered from1 to n.

There are n directed roads in the Udayland. i-th of them goes from town i to some other town ai (ai ≠ i). ZS the Coder can flip the direction of any road in Udayland, i.e. if it goes from town A to town B before the flip, it will go from town B to town A after.

ZS the Coder considers the roads in the Udayland confusing, if there is a sequence of distinct towns A1, A2, ..., Ak (k > 1) such that for every 1 ≤ i < k there is a road from town Ai to town Ai + 1 and another road from town Ak to town A1. In other words, the roads are confusing if some of them form a directed cycle of some towns.

Now ZS the Coder wonders how many sets of roads (there are 2n variants) in initial configuration can he choose to flip such that after flipping each road in the set exactly once, the resulting network will not be confusing.

Note that it is allowed that after the flipping there are more than one directed road from some town and possibly some towns with no roads leading out of it, or multiple roads between any pair of cities.

Input

The first line of the input contains single integer n (2 ≤ n ≤ 2·105) — the number of towns in Udayland.

The next line contains n integers a1, a2, ..., an (1 ≤ ai ≤ n, ai ≠ i), ai denotes a road going from town i to town ai.

Output

Print a single integer — the number of ways to flip some set of the roads so that the resulting whole set of all roads is not confusing. Since this number may be too large, print the answer modulo 109 + 7.

Examples
input
3
2 3 1
output
6
input
4
2 1 1 1
output
8
input
5
2 4 2 5 3
output
28

题意:

给出一个n个节点n条边的有向图,可以把一条边反向,现在问有多少种方式可以使这个图没有环;

思路:

可以发现,对于一个环来说,随便反转哪些边就可以,不过有两种不行就是都不反转和都反转,假设这个环有n条边,那么就有2^n-2种方式,其他不在环里的边可以反转可以不反转;

AC代码:
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <bits/stdc++.h>
#include <stack>
#include <map>
 
using namespace std;
 
#define For(i,j,n) for(int i=j;i<=n;i++)
#define mst(ss,b) memset(ss,b,sizeof(ss));
 
typedef  long long LL;
 
template<class T> void read(T&num) {
    char CH; bool F=false;
    for(CH=getchar();CH<'0'||CH>'9';F= CH=='-',CH=getchar());
    for(num=0;CH>='0'&&CH<='9';num=num*10+CH-'0',CH=getchar());
    F && (num=-num);
}
int stk[70], tp;
template<class T> inline void print(T p) {
    if(!p) { puts("0"); return; }
    while(p) stk[++ tp] = p%10, p/=10;
    while(tp) putchar(stk[tp--] + '0');
    putchar('\n');
}
 
const LL mod=1e9+7;
const double PI=acos(-1.0);
const int inf=1e9;
const int N=2e5+10;
const int maxn=1e3+520;
const double eps=1e-12;

int n,a[N],vis[N],dep[N],sum=0;
LL ans=1;
LL pow_mod(int x)
{
    LL s=1,base=2;
    while(x)
    {
        if(x&1)s=s*base%mod;
        base=base*base%mod;
        x>>=1;
    }
    return s;
}
int dfs(int cur,int deep,int fa)
{
    vis[cur]=fa;
    dep[cur]=deep;
    if(!vis[a[cur]])dfs(a[cur],deep+1,fa);
    else if(vis[a[cur]]==fa)
    {
        ans=ans*(pow_mod(dep[cur]-dep[a[cur]]+1)-2+mod)%mod;
        sum+=dep[cur]-dep[a[cur]]+1;
    }
}
int main()
{
    read(n);
    For(i,1,n)read(a[i]);
    For(i,1,n)if(!vis[i])dfs(i,0,i);
    ans=ans*pow_mod(n-sum)%mod;
    cout<<ans<<endl;
    return 0;
}

  

posted @ 2016-08-30 09:52  LittlePointer  阅读(385)  评论(0编辑  收藏  举报